/*
 * $Id: icons2.prg 2961 2021-03-14 10:25:21Z df7be $
 *
 * HWGUI - Harbour Win32 and Linux (GTK) GUI library
 *
 *  icons2.prg
 *
 * Sample for icons and bitmaps
 * using hex values
 *
 * Copyright 2021 Wilfried Brunken, DF7BE 
 * https://sourceforge.net/projects/cllog/
 * 
 * For validating Ticket #61
 */
 
    * Status:
    *  WinAPI   :  Yes
    *  GTK/Linux:  Yes
    *  GTK/Win  :  Yes  


#include "hwgui.ch"
#ifdef __GTK__
#include "gtk.ch"
#endif

MEMVAR oMainWindow
MEMVAR oObj_Window, oObj_Dialog
MEMVAR cVal_Window, cVal_Dialog, oImg_Window, oImg_Dialog
MEMVAR cCmd

MEMVAR cHexDbmp , cHexDico , cHexWbmp , cHexWico
MEMVAR cVal_WIco , cVal_Wbmp , cVal_DIco , cVal_Dbmp
MEMVAR nMainX, nMainY

* --------------------------------------------
FUNCTION Main
* --------------------------------------------
PUBLIC oMainWindow
PUBLIC oObj_Window, oObj_Dialog
PUBLIC cVal_Window, cVal_Dialog, oImg_Window, oImg_Dialog
PUBLIC cCmd
 cCmd := "Test main Window"



PUBLIC cHexDbmp , cHexDico , cHexWbmp , cHexWico
PUBLIC cVal_WIco , cVal_Wbmp , cVal_DIco , cVal_Dbmp
PUBLIC nMainX, nMainY

Init_Hexvars()

cVal_WIco := hwg_cHex2Bin(cHexWico)
cVal_Wbmp := hwg_cHex2Bin(cHexWbmp)
cVal_DIco := hwg_cHex2Bin(cHexDico)
cVal_Dbmp := hwg_cHex2Bin(cHexDbmp)


* ICO
oObj_Window := HIcon():AddString( "Window" , cVal_WIco )
oObj_Dialog := HIcon():AddString( "Dialog" , cVal_DIco )
* BMP
oImg_Window := HBitmap():AddString( "Window" , cVal_Wbmp )
oImg_Dialog := HBitmap():AddString( "Dialog" , cVal_Dbmp )

   INIT WINDOW oMainWindow TITLE "Dialog icon test" ;
     AT 100,80 SIZE 300, 300 ICON oObj_Window

 
  nMainX := oMainWindow:nLeft + 60
  nMainY := oMainWindow:nTop + 175

   MENU OF oMainWindow  
      MENU TITLE "&Exit"
        MENUITEM "&Quit" ACTION oMainWindow:Close()
      ENDMENU
      MENU TITLE "&Dialog"
        MENUITEM "&Open" ACTION Test()
      ENDMENU
   ENDMENU

   @  20, 0 SAY cCmd SIZE 250,40   


#ifdef __GTK__
/* Does not work on Windows (Format *.ico) */
   @  50,60 BITMAP oObj_Window  
   @ 160,60 BITMAP oObj_Dialog
   && --------------------
   @  30, 150 SAY "Window icon" SIZE 80,32
   @ 140, 150 SAY "Dialog icon" SIZE 80,32   
#else 

   @  50, 60 BITMAP oImg_Window 
   @ 160, 60 BITMAP oImg_Dialog  
   
   @  30, 150 SAY "Window Bitmap" SIZE 80,32
   @ 140, 150 SAY "Dialog Bitmap" SIZE 80,32
#endif


   ACTIVATE WINDOW oMainWindow   
   
RETURN NIL

* --------------------------------------------
FUNCTION Test()
* --------------------------------------------
LOCAL cTitle := "Dialog icon", oDialog
LOCAL ctext  := "-- Dialog --"
LOCAL ctxt   := "icon displayed with @x,y Bitmap" 
  
//  INIT DIALOG oDialog TITLE cTitle AT oMainWindow:nLeft+60,oMainWindow:nTop+175  SIZE 400,400 ;
   INIT DIALOG oDialog TITLE cTitle AT nMainX, nMainY SIZE 400,400 ;
     ICON oObj_Dialog

      @ 10 , 20  SAY ctext SIZE 270, 90
      @ 20 , 120 SAY ctxt  SIZE 180, 48

  

/*
  GTK: crashes here with core dump memory access violation,
  if dialog is called twice.
*/
#ifdef __GTK__
      @ 210, 118 BITMAP   oObj_Dialog
#else
      @ 210, 118 BITMAP   oImg_Dialog
#endif

      @ 150,350 BUTTON "OK" SIZE 100, 32 ON CLICK {|| oDialog:Close() }


   ACTIVATE DIALOG oDialog

  RETURN Nil

* --------------------------------------------
FUNCTION Init_Hexvars()
* --------------------------------------------

* --- D.bmp ---
cHexDbmp := ;
"42 4D 36 0D 00 00 00 00 00 00 36 04 00 00 28 00 " + ;
"00 00 30 00 00 00 30 00 00 00 01 00 08 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 FF 00 3A 3A FF 00 7E 7E " + ;
"FF 00 7C 7C FF 00 73 73 FF 00 62 62 FF 00 46 46 " + ;
"FF 00 22 22 FF 00 75 75 FF 00 FF FF FF 00 E5 E5 " + ;
"FF 00 99 99 FF 00 2B 2B FF 00 A2 A2 FF 00 10 10 " + ;
"FF 00 E0 E0 FF 00 2A 2A FF 00 FA FA FF 00 86 86 " + ;
"FF 00 96 96 FF 00 B3 B3 FF 00 D9 D9 FF 00 EA EA " + ;
"FF 00 28 28 FF 00 F6 F6 FF 00 1D 1D FF 00 92 92 " + ;
"FF 00 DE DE FF 00 0C 0C FF 00 38 38 FF 00 9D 9D " + ;
"FF 00 30 30 FF 00 F5 F5 FF 00 FC FC FF 00 29 29 " + ;
"FF 00 64 64 FF 00 CF CF FF 00 0B 0B FF 00 5B 5B " + ;
"FF 00 56 56 FF 00 9A 9A FF 00 C9 C9 FF 00 D0 D0 " + ;
"FF 00 7D 7D FF 00 13 13 FF 00 6C 6C FF 00 27 27 " + ;
"FF 00 2C 2C FF 00 7A 7A FF 00 18 18 FF 00 F8 F8 " + ;
"FF 00 02 02 FF 00 C7 C7 FF 00 DA DA FF 00 05 05 " + ;
"FF 00 A5 A5 FF 00 4B 4B FF 00 66 66 FF 00 A9 A9 " + ;
"FF 00 19 19 FF 00 BA BA FF 00 C1 C1 FF 00 94 94 " + ;
"FF 00 21 21 FF 00 B4 B4 FF 00 06 06 FF 00 1A 1A " + ;
"FF 00 37 37 FF 00 69 69 FF 00 B2 B2 FF 00 81 81 " + ;
"FF 00 F0 F0 FF 00 5F 5F FF 00 91 91 FF 00 17 17 " + ;
"FF 00 F3 F3 FF 00 DB DB FF 00 B8 B8 FF 00 89 89 " + ;
"FF 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 4B " + ;
"4C 4D 4E 38 36 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 09 47 49 4A 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 47 48 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 46 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 41 42 " + ;
"43 44 45 21 09 09 09 09 09 39 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 3F 40 09 09 09 09 32 1F 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 3E 09 09 09 09 34 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 33 3D 09 09 09 09 38 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 22 21 09 09 09 3C 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 3A 09 09 09 21 3B 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 38 09 09 09 09 39 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 36 20 09 09 09 37 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 34 09 09 09 35 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 1E 09 09 09 32 33 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 30 09 09 09 09 31 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 2D 09 09 09 09 10 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 05 09 09 09 09 2F 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 05 09 09 09 09 2F 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 2D 09 09 09 09 2E 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 2B 09 09 09 09 2C 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 1E 09 09 09 20 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 29 09 09 09 2A 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 25 11 09 09 09 28 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 26 09 09 09 09 27 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 24 09 09 09 20 25 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 23 09 09 09 09 0D 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 1F 20 09 09 09 21 22 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 1D 16 09 09 09 09 1E 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 18 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 19 1A 11 09 09 09 09 1B 1C 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 11 02 02 02 02 02 02 02 02 12 13 " + ;
"14 15 09 09 09 09 09 09 16 17 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 0F 10 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 0D 0E 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 08 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"09 09 09 0A 0B 0C 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 01 02 02 02 02 02 02 02 02 02 02 02 02 03 04 " + ;
"05 06 07 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 "

* --- D.ico ---

cHexDico := ;
"00 00 01 00 01 00 30 30 00 00 01 00 08 00 A8 0E " + ;
"00 00 16 00 00 00 28 00 00 00 30 00 00 00 60 00 " + ;
"00 00 01 00 08 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"FF 00 3A 3A FF 00 7E 7E FF 00 7C 7C FF 00 73 73 " + ;
"FF 00 62 62 FF 00 46 46 FF 00 22 22 FF 00 75 75 " + ;
"FF 00 FF FF FF 00 E5 E5 FF 00 99 99 FF 00 2B 2B " + ;
"FF 00 A2 A2 FF 00 10 10 FF 00 E0 E0 FF 00 2A 2A " + ;
"FF 00 FA FA FF 00 86 86 FF 00 96 96 FF 00 B3 B3 " + ;
"FF 00 D9 D9 FF 00 EA EA FF 00 28 28 FF 00 F6 F6 " + ;
"FF 00 1D 1D FF 00 92 92 FF 00 DE DE FF 00 0C 0C " + ;
"FF 00 38 38 FF 00 9D 9D FF 00 30 30 FF 00 F5 F5 " + ;
"FF 00 FC FC FF 00 29 29 FF 00 64 64 FF 00 CF CF " + ;
"FF 00 0B 0B FF 00 5B 5B FF 00 56 56 FF 00 9A 9A " + ;
"FF 00 C9 C9 FF 00 D0 D0 FF 00 7D 7D FF 00 13 13 " + ;
"FF 00 6C 6C FF 00 27 27 FF 00 2C 2C FF 00 7A 7A " + ;
"FF 00 18 18 FF 00 F8 F8 FF 00 02 02 FF 00 C7 C7 " + ;
"FF 00 DA DA FF 00 05 05 FF 00 A5 A5 FF 00 4B 4B " + ;
"FF 00 66 66 FF 00 A9 A9 FF 00 19 19 FF 00 BA BA " + ;
"FF 00 C1 C1 FF 00 94 94 FF 00 21 21 FF 00 B4 B4 " + ;
"FF 00 06 06 FF 00 1A 1A FF 00 37 37 FF 00 69 69 " + ;
"FF 00 B2 B2 FF 00 81 81 FF 00 F0 F0 FF 00 5F 5F " + ;
"FF 00 91 91 FF 00 17 17 FF 00 F3 F3 FF 00 DB DB " + ;
"FF 00 B8 B8 FF 00 89 89 FF 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 4B 4C 4D 4E 38 36 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 09 47 49 4A 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 09 09 09 47 48 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 09 09 09 09 09 " + ;
"46 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 41 42 43 44 45 21 09 09 09 09 " + ;
"09 39 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 3F 40 09 09 09 " + ;
"09 32 1F 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 3E 09 09 " + ;
"09 09 34 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 33 3D 09 " + ;
"09 09 09 38 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 22 21 " + ;
"09 09 09 3C 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 3A " + ;
"09 09 09 21 3B 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 38 " + ;
"09 09 09 09 39 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 36 " + ;
"20 09 09 09 37 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"34 09 09 09 35 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"1E 09 09 09 32 33 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"30 09 09 09 09 31 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"2D 09 09 09 09 10 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"05 09 09 09 09 2F 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"05 09 09 09 09 2F 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"2D 09 09 09 09 2E 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"2B 09 09 09 09 2C 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"1E 09 09 09 20 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"29 09 09 09 2A 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 25 " + ;
"11 09 09 09 28 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 26 " + ;
"09 09 09 09 27 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 24 " + ;
"09 09 09 20 25 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 23 09 " + ;
"09 09 09 0D 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 1F 20 09 " + ;
"09 09 21 22 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 1D 16 09 09 " + ;
"09 09 1E 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 18 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 19 1A 11 09 09 09 " + ;
"09 1B 1C 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 11 02 02 " + ;
"02 02 02 02 02 02 12 13 14 15 09 09 09 09 09 09 " + ;
"16 17 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 09 09 09 09 0F " + ;
"10 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 09 09 09 0D 0E " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 08 09 09 09 09 09 09 " + ;
"09 09 09 09 09 09 09 09 09 09 09 0A 0B 0C 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 01 02 02 02 02 02 02 " + ;
"02 02 02 02 02 02 03 04 05 06 07 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 "


* --- W.bmp ---
cHexWbmp := ;
"42 4D 36 0D 00 00 00 00 00 00 36 04 00 00 28 00 " + ;
"00 00 30 00 00 00 30 00 00 00 01 00 08 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 FF 00 00 33 FF 33 00 7E FF " + ;
"7E 00 13 FF 13 00 3A FF 3A 00 0B FF 0B 00 50 FF " + ;
"50 00 6B FF 6B 00 32 FF 32 00 FF FF FF 00 54 FF " + ;
"54 00 B0 FF B0 00 49 FF 49 00 D2 FF D2 00 9E FF " + ;
"9E 00 02 FF 02 00 EC FF EC 00 90 FF 90 00 05 FF " + ;
"05 00 F0 FF F0 00 92 FF 92 00 12 FF 12 00 FC FF " + ;
"FC 00 59 FF 59 00 A9 FF A9 00 CC FF CC 00 3F FF " + ;
"3F 00 DC FF DC 00 4B FF 4B 00 14 FF 14 00 66 FF " + ;
"66 00 FA FF FA 00 09 FF 09 00 8A FF 8A 00 F3 FF " + ;
"F3 00 24 FF 24 00 8C FF 8C 00 CA FF CA 00 41 FF " + ;
"41 00 F5 FF F5 00 93 FF 93 00 6C FF 6C 00 85 FF " + ;
"85 00 DE FF DE 00 7B FF 7B 00 1C FF 1C 00 BC FF " + ;
"BC 00 46 FF 46 00 B4 FF B4 00 0E FF 0E 00 3B FF " + ;
"3B 00 9C FF 9C 00 B7 FF B7 00 64 FF 64 00 79 FF " + ;
"79 00 56 FF 56 00 F1 FF F1 00 44 FF 44 00 17 FF " + ;
"17 00 2E FF 2E 00 E9 FF E9 00 6F FF 6F 00 8F FF " + ;
"8F 00 69 FF 69 00 42 FF 42 00 A1 FF A1 00 26 FF " + ;
"26 00 D5 FF D5 00 A5 FF A5 00 1E FF 1E 00 E2 FF " + ;
"E2 00 95 FF 95 00 C7 FF C7 00 4E FF 4E 00 C2 FF " + ;
"C2 00 82 FF 82 00 10 FF 10 00 94 FF 94 00 39 FF " + ;
"39 00 C0 FF C0 00 EE FF EE 00 80 FF 80 00 87 FF " + ;
"87 00 B2 FF B2 00 5E FF 5E 00 19 FF 19 00 5B FF " + ;
"5B 00 A4 FF A4 00 29 FF 29 00 E7 FF E7 00 DF FF " + ;
"DF 00 AA FF AA 00 36 FF 36 00 D7 FF D7 00 76 FF " + ;
"76 00 51 FF 51 00 4A FF 4A 00 55 FF 55 00 AC FF " + ;
"AC 00 34 FF 34 00 B6 FF B6 00 A7 FF A7 00 99 FF " + ;
"99 00 BA FF BA 00 C5 FF C5 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 67 09 09 09 09 42 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 43 09 09 09 68 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"12 27 09 09 09 09 3D 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 2D 09 09 09 09 1F 31 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"26 09 09 09 09 09 34 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 54 09 09 09 09 09 5F 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"52 09 09 09 09 09 27 20 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 65 09 09 09 09 09 66 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"48 09 09 1F 09 09 09 2F 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 0F 10 09 09 1F 09 09 2B 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 31 " + ;
"16 09 09 62 09 09 09 3E 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 63 09 09 09 64 09 09 09 42 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 5F " + ;
"09 09 09 60 22 09 09 5D 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 2C 09 09 09 61 09 09 09 3D 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 47 " + ;
"09 09 09 15 34 09 09 09 45 00 00 00 00 00 00 00 " + ;
"00 00 00 00 4F 09 09 38 12 27 09 09 30 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 5D " + ;
"09 09 5A 00 5E 09 09 09 1E 00 00 00 00 00 00 00 " + ;
"00 00 00 05 1F 09 09 4A 00 4A 09 09 27 12 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 2D 09 " + ;
"09 09 5B 00 5C 09 09 09 0B 00 00 00 00 00 00 00 " + ;
"00 00 00 49 09 09 09 24 00 4B 09 09 09 39 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 54 09 " + ;
"09 09 07 00 0F 22 09 09 22 12 00 00 00 00 00 00 " + ;
"00 00 00 47 09 09 09 37 00 2F 09 09 09 21 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 57 09 " + ;
"09 09 08 00 00 53 09 09 09 1A 00 00 00 00 00 00 " + ;
"00 00 00 1B 09 09 09 2D 00 05 1F 09 09 0D 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 59 09 " + ;
"09 22 0F 00 00 1E 09 09 09 52 00 00 00 00 00 00 " + ;
"00 00 45 09 09 09 5A 00 00 00 48 09 09 16 3A 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 58 09 09 " + ;
"09 2E 00 00 00 2D 09 09 09 0D 00 00 00 00 00 00 " + ;
"00 00 1E 09 09 09 0E 00 00 00 52 09 09 09 56 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 3D 09 09 " + ;
"09 4B 00 00 00 00 43 09 09 09 55 00 00 00 00 00 " + ;
"00 00 0B 09 09 09 56 00 00 00 2F 09 09 09 57 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 53 09 09 " + ;
"09 39 00 00 00 00 21 09 09 09 54 00 00 00 00 00 " + ;
"00 0F 13 09 09 09 55 00 00 00 05 1F 09 09 3C 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 0F 22 09 09 " + ;
"16 05 00 00 00 00 40 09 09 09 18 00 00 00 00 00 " + ;
"00 32 09 09 09 0D 00 00 00 00 00 48 09 09 09 08 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 4E 09 09 09 " + ;
"19 00 00 00 00 00 12 22 09 09 50 0F 00 00 00 00 " + ;
"00 51 09 09 09 52 00 00 00 00 00 52 09 09 09 36 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 2C 09 09 09 " + ;
"4D 00 00 00 00 00 00 0B 09 09 09 4E 00 00 00 00 " + ;
"00 48 09 09 09 1A 00 00 00 00 00 2F 09 09 09 4F " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 4A 09 09 09 " + ;
"37 00 00 00 00 00 00 1E 09 09 09 4B 00 00 00 00 " + ;
"4C 16 09 09 22 12 00 00 00 00 00 05 1F 09 09 1F " + ;
"05 00 00 00 00 00 00 00 00 00 00 05 1F 09 09 09 " + ;
"2D 00 00 00 00 00 00 2D 09 09 09 25 00 00 00 00 " + ;
"0A 09 09 09 0B 00 00 00 00 00 00 00 48 09 09 09 " + ;
"49 00 00 00 00 00 00 00 00 00 00 2F 09 09 09 46 " + ;
"00 00 00 00 00 00 00 00 43 09 09 16 1D 00 00 00 " + ;
"33 09 09 09 1E 00 00 00 00 00 00 00 24 09 09 09 " + ;
"47 00 00 00 00 00 00 00 00 00 00 24 09 09 09 44 " + ;
"00 00 00 00 00 00 00 00 21 09 09 09 17 00 00 00 " + ;
"2B 09 09 09 45 00 00 00 00 00 00 00 1C 09 09 09 " + ;
"1B 00 00 00 00 00 00 00 00 00 00 0D 09 09 09 3F " + ;
"00 00 00 00 00 00 00 00 40 09 09 09 41 00 00 42 " + ;
"09 09 09 43 00 00 00 00 00 00 00 00 31 16 09 09 " + ;
"09 23 00 00 00 00 00 00 00 00 3A 16 09 09 09 3B " + ;
"00 00 00 00 00 00 00 00 12 13 09 09 3C 00 00 3D " + ;
"09 09 09 3E 00 00 00 00 00 00 00 00 00 19 09 09 " + ;
"09 1E 00 00 00 00 00 00 00 00 37 09 09 09 38 0F " + ;
"00 00 00 00 00 00 00 00 00 0B 09 09 09 08 00 30 " + ;
"09 09 09 39 00 00 00 00 00 00 00 00 00 24 09 09 " + ;
"09 0B 00 00 00 00 00 00 00 00 33 09 09 09 34 00 " + ;
"00 00 00 00 00 00 00 00 00 35 09 09 09 36 12 27 " + ;
"09 09 27 12 00 00 00 00 00 00 00 00 00 1C 09 09 " + ;
"09 13 0F 00 00 00 00 00 00 00 2B 09 09 09 2C 00 " + ;
"00 00 00 00 00 00 00 00 00 2D 09 09 09 2E 2F 09 " + ;
"09 09 30 00 00 00 00 00 00 00 00 00 00 31 16 09 " + ;
"09 09 32 00 00 00 00 00 00 23 09 09 09 09 26 00 " + ;
"00 00 00 00 00 00 00 00 00 00 0D 09 09 27 28 09 " + ;
"09 09 29 00 00 00 00 00 00 00 00 00 00 00 19 09 " + ;
"09 09 2A 00 00 00 00 00 00 1E 09 09 09 1F 20 00 " + ;
"00 00 00 00 00 00 00 00 00 00 21 09 09 09 22 09 " + ;
"09 09 23 00 00 00 00 00 00 00 00 00 00 00 24 09 " + ;
"09 09 25 00 00 00 00 00 00 18 09 09 09 19 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 1A 09 09 09 09 09 " + ;
"09 1B 00 00 00 00 00 00 00 00 00 00 00 00 1C 09 " + ;
"09 09 16 1D 00 00 00 00 0F 10 09 09 09 11 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 12 13 09 09 09 09 " + ;
"09 14 00 00 00 00 00 00 00 00 00 00 00 00 15 16 " + ;
"09 09 09 17 00 00 00 00 08 09 09 09 09 0A 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 0B 09 09 09 09 " + ;
"09 0C 00 00 00 00 00 00 00 00 00 00 00 00 00 0D " + ;
"09 09 09 0E 00 00 00 00 01 02 02 02 02 03 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 04 02 02 02 02 " + ;
"02 05 00 00 00 00 00 00 00 00 00 00 00 00 00 06 " + ;
"02 02 02 07 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 "

* --- W.ico ---
cHexWico := ;
"00 00 01 00 01 00 30 30 00 00 01 00 08 00 A8 0E " + ;
"00 00 16 00 00 00 28 00 00 00 30 00 00 00 60 00 " + ;
"00 00 01 00 08 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 FF " + ;
"00 00 33 FF 33 00 7E FF 7E 00 13 FF 13 00 3A FF " + ;
"3A 00 0B FF 0B 00 50 FF 50 00 6B FF 6B 00 32 FF " + ;
"32 00 FF FF FF 00 54 FF 54 00 B0 FF B0 00 49 FF " + ;
"49 00 D2 FF D2 00 9E FF 9E 00 02 FF 02 00 EC FF " + ;
"EC 00 90 FF 90 00 05 FF 05 00 F0 FF F0 00 92 FF " + ;
"92 00 12 FF 12 00 FC FF FC 00 59 FF 59 00 A9 FF " + ;
"A9 00 CC FF CC 00 3F FF 3F 00 DC FF DC 00 4B FF " + ;
"4B 00 14 FF 14 00 66 FF 66 00 FA FF FA 00 09 FF " + ;
"09 00 8A FF 8A 00 F3 FF F3 00 24 FF 24 00 8C FF " + ;
"8C 00 CA FF CA 00 41 FF 41 00 F5 FF F5 00 93 FF " + ;
"93 00 6C FF 6C 00 85 FF 85 00 DE FF DE 00 7B FF " + ;
"7B 00 1C FF 1C 00 BC FF BC 00 46 FF 46 00 B4 FF " + ;
"B4 00 0E FF 0E 00 3B FF 3B 00 9C FF 9C 00 B7 FF " + ;
"B7 00 64 FF 64 00 79 FF 79 00 56 FF 56 00 F1 FF " + ;
"F1 00 44 FF 44 00 17 FF 17 00 2E FF 2E 00 E9 FF " + ;
"E9 00 6F FF 6F 00 8F FF 8F 00 69 FF 69 00 42 FF " + ;
"42 00 A1 FF A1 00 26 FF 26 00 D5 FF D5 00 A5 FF " + ;
"A5 00 1E FF 1E 00 E2 FF E2 00 95 FF 95 00 C7 FF " + ;
"C7 00 4E FF 4E 00 C2 FF C2 00 82 FF 82 00 10 FF " + ;
"10 00 94 FF 94 00 39 FF 39 00 C0 FF C0 00 EE FF " + ;
"EE 00 80 FF 80 00 87 FF 87 00 B2 FF B2 00 5E FF " + ;
"5E 00 19 FF 19 00 5B FF 5B 00 A4 FF A4 00 29 FF " + ;
"29 00 E7 FF E7 00 DF FF DF 00 AA FF AA 00 36 FF " + ;
"36 00 D7 FF D7 00 76 FF 76 00 51 FF 51 00 4A FF " + ;
"4A 00 55 FF 55 00 AC FF AC 00 34 FF 34 00 B6 FF " + ;
"B6 00 A7 FF A7 00 99 FF 99 00 BA FF BA 00 C5 FF " + ;
"C5 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 67 09 09 09 09 42 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 43 09 " + ;
"09 09 68 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 12 27 09 09 09 09 3D 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 2D 09 09 " + ;
"09 09 1F 31 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 26 09 09 09 09 09 34 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 54 09 09 " + ;
"09 09 09 5F 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 52 09 09 09 09 09 27 20 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 65 09 09 " + ;
"09 09 09 66 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 48 09 09 1F 09 09 09 2F " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 0F 10 09 09 " + ;
"1F 09 09 2B 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 31 16 09 09 62 09 09 09 3E " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 63 09 09 09 " + ;
"64 09 09 09 42 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 5F 09 09 09 60 22 09 09 5D " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 2C 09 09 09 " + ;
"61 09 09 09 3D 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 47 09 09 09 15 34 09 09 09 " + ;
"45 00 00 00 00 00 00 00 00 00 00 00 4F 09 09 38 " + ;
"12 27 09 09 30 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 5D 09 09 5A 00 5E 09 09 09 " + ;
"1E 00 00 00 00 00 00 00 00 00 00 05 1F 09 09 4A " + ;
"00 4A 09 09 27 12 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 2D 09 09 09 5B 00 5C 09 09 09 " + ;
"0B 00 00 00 00 00 00 00 00 00 00 49 09 09 09 24 " + ;
"00 4B 09 09 09 39 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 54 09 09 09 07 00 0F 22 09 09 " + ;
"22 12 00 00 00 00 00 00 00 00 00 47 09 09 09 37 " + ;
"00 2F 09 09 09 21 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 57 09 09 09 08 00 00 53 09 09 " + ;
"09 1A 00 00 00 00 00 00 00 00 00 1B 09 09 09 2D " + ;
"00 05 1F 09 09 0D 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 59 09 09 22 0F 00 00 1E 09 09 " + ;
"09 52 00 00 00 00 00 00 00 00 45 09 09 09 5A 00 " + ;
"00 00 48 09 09 16 3A 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 58 09 09 09 2E 00 00 00 2D 09 09 " + ;
"09 0D 00 00 00 00 00 00 00 00 1E 09 09 09 0E 00 " + ;
"00 00 52 09 09 09 56 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 3D 09 09 09 4B 00 00 00 00 43 09 " + ;
"09 09 55 00 00 00 00 00 00 00 0B 09 09 09 56 00 " + ;
"00 00 2F 09 09 09 57 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 53 09 09 09 39 00 00 00 00 21 09 " + ;
"09 09 54 00 00 00 00 00 00 0F 13 09 09 09 55 00 " + ;
"00 00 05 1F 09 09 3C 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 0F 22 09 09 16 05 00 00 00 00 40 09 " + ;
"09 09 18 00 00 00 00 00 00 32 09 09 09 0D 00 00 " + ;
"00 00 00 48 09 09 09 08 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 4E 09 09 09 19 00 00 00 00 00 12 22 " + ;
"09 09 50 0F 00 00 00 00 00 51 09 09 09 52 00 00 " + ;
"00 00 00 52 09 09 09 36 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 2C 09 09 09 4D 00 00 00 00 00 00 0B " + ;
"09 09 09 4E 00 00 00 00 00 48 09 09 09 1A 00 00 " + ;
"00 00 00 2F 09 09 09 4F 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 4A 09 09 09 37 00 00 00 00 00 00 1E " + ;
"09 09 09 4B 00 00 00 00 4C 16 09 09 22 12 00 00 " + ;
"00 00 00 05 1F 09 09 1F 05 00 00 00 00 00 00 00 " + ;
"00 00 00 05 1F 09 09 09 2D 00 00 00 00 00 00 2D " + ;
"09 09 09 25 00 00 00 00 0A 09 09 09 0B 00 00 00 " + ;
"00 00 00 00 48 09 09 09 49 00 00 00 00 00 00 00 " + ;
"00 00 00 2F 09 09 09 46 00 00 00 00 00 00 00 00 " + ;
"43 09 09 16 1D 00 00 00 33 09 09 09 1E 00 00 00 " + ;
"00 00 00 00 24 09 09 09 47 00 00 00 00 00 00 00 " + ;
"00 00 00 24 09 09 09 44 00 00 00 00 00 00 00 00 " + ;
"21 09 09 09 17 00 00 00 2B 09 09 09 45 00 00 00 " + ;
"00 00 00 00 1C 09 09 09 1B 00 00 00 00 00 00 00 " + ;
"00 00 00 0D 09 09 09 3F 00 00 00 00 00 00 00 00 " + ;
"40 09 09 09 41 00 00 42 09 09 09 43 00 00 00 00 " + ;
"00 00 00 00 31 16 09 09 09 23 00 00 00 00 00 00 " + ;
"00 00 3A 16 09 09 09 3B 00 00 00 00 00 00 00 00 " + ;
"12 13 09 09 3C 00 00 3D 09 09 09 3E 00 00 00 00 " + ;
"00 00 00 00 00 19 09 09 09 1E 00 00 00 00 00 00 " + ;
"00 00 37 09 09 09 38 0F 00 00 00 00 00 00 00 00 " + ;
"00 0B 09 09 09 08 00 30 09 09 09 39 00 00 00 00 " + ;
"00 00 00 00 00 24 09 09 09 0B 00 00 00 00 00 00 " + ;
"00 00 33 09 09 09 34 00 00 00 00 00 00 00 00 00 " + ;
"00 35 09 09 09 36 12 27 09 09 27 12 00 00 00 00 " + ;
"00 00 00 00 00 1C 09 09 09 13 0F 00 00 00 00 00 " + ;
"00 00 2B 09 09 09 2C 00 00 00 00 00 00 00 00 00 " + ;
"00 2D 09 09 09 2E 2F 09 09 09 30 00 00 00 00 00 " + ;
"00 00 00 00 00 31 16 09 09 09 32 00 00 00 00 00 " + ;
"00 23 09 09 09 09 26 00 00 00 00 00 00 00 00 00 " + ;
"00 00 0D 09 09 27 28 09 09 09 29 00 00 00 00 00 " + ;
"00 00 00 00 00 00 19 09 09 09 2A 00 00 00 00 00 " + ;
"00 1E 09 09 09 1F 20 00 00 00 00 00 00 00 00 00 " + ;
"00 00 21 09 09 09 22 09 09 09 23 00 00 00 00 00 " + ;
"00 00 00 00 00 00 24 09 09 09 25 00 00 00 00 00 " + ;
"00 18 09 09 09 19 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 1A 09 09 09 09 09 09 1B 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 1C 09 09 09 16 1D 00 00 00 00 " + ;
"0F 10 09 09 09 11 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 12 13 09 09 09 09 09 14 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 15 16 09 09 09 17 00 00 00 00 " + ;
"08 09 09 09 09 0A 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 0B 09 09 09 09 09 0C 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 0D 09 09 09 0E 00 00 00 00 " + ;
"01 02 02 02 02 03 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 04 02 02 02 02 02 05 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 06 02 02 02 07 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 " + ;
"00 00 00 00 00 00 00 00 00 00 00 00 00 00 "


RETURN NIL

* ================= EOF of icons2.prg =================
